//
//  T[`
//

#include "kyokumen.h"
#include "gen_moves.h"
#include "gen_cap.h"
#include "gen_evasion.h"
#include "make_move.h"
#include "hash.h"
#include "see.h"
#include "material.h"
#include "evaluate.h"

#include <algorithm>

// P[̕\B[0.5ɑΉł悤ɁB
#define INC_PLY	 4
// őAŏl
#define VMIN	-99999999
#define VMAX	 99999999

// 
struct kyokumen_t ptree;		// ݂̋ǖ	
struct te_t TE[48][600];		// ̃Xg
struct te_t pv_node[32][32];	// PVm[h
struct te_t killer1[32];		// L[1
struct te_t killer2[32];		// L[2
struct te_t last_move[32];		// OɎwĎ
char   in_check_ply[32];		// 肩ۂ̏
uint64 hash_hist[32];			// JԂȂ悤ɂ邽߁ATƂɃnbVlۑ

int tesu;				// ݂̎萔

// ʕ\p	 
int search_node;		// Tm[h
int iteration;			// ݂̃C^[V
int hash_hit;			// nbVqbg
 
// Ԑp
int finterrupt;				// Tł؂ꂽۂ 
unsigned int TIMEOUT;		// T[msec]
DWORD T0;					// TJn

#define NULL_MOVE_PRUNING_DONE	1

// qXg[ϐ
unsigned short hist_good[100][81];		// JbgN̉
unsigned short hist_tried[100][81];		// Tꂽ̉

#define psign(x)	(x==0?1:-1)


//
//  Î~T
//
int quies(
	int player,
	int alpha, int beta, 
	int ply,
	int state				
	)
{
	int i, num;

	// ԂɒB
	if((::GetTickCount() - T0) > TIMEOUT)
	{
		finterrupt = 1;
		return -999999;
	}

	te_t *te = TE[ply];
	// ݂̋ǖʂ̕]l
	int stand_pat0 =  evaluate(player, ptree);
	int stand_pat  =  stand_pat0 / 32;

	search_node++;
	
	// T[ɒB
	if(ply > 20)
		return stand_pat;

	// Jbg
	if ( alpha < stand_pat )
	{
		if ( beta <= stand_pat )
		{
			return stand_pat;
		}
		alpha = stand_pat;
	}


	// @̐(̂)
	num = gen_capture(player, &ptree, te);
	// 肪ȂΑԂ
	if(num == 0)
		return stand_pat;

	// w̃I[_O(SEE)
	for(i = 0;i < num;i++)
	{
		int see_v = see(player, ptree, te[i]);
		te[i].v = see_v;
		// see͖̎
		if(see_v < 0)
			te[i].v = -100000;
	}
	// \[gs
	std::sort(&te[0], &te[num]);

	// unmake_movepɕۑ
	kyokumen_t prev = ptree;

	// ݁A肩ۂH
	int f_in_check;
	f_in_check = in_check_ply[ply];

	for(i = 0;i < num; i++)
	{
		// wte[i]ƂȂ邩H
		int fmovecheck = is_check_move(player, ptree, te[i]);
		// see̎Ɖ͖
		if(te[i].v < -10000 ||  fmovecheck == 1)
			continue;

		// futility cut
		if(
			f_in_check == 0 && fmovecheck == 0 && i > 0)
		{
			int bound = alpha;
			int estimate_v0 = estimate_value(stand_pat, player, ptree, te[i]);
			int estimate_v  = estimate_v0 / 32;
			if(estimate_v <= bound) 
			{
				// ߂
				continue;
			};
		}
		// i߂
		make_move(player, &ptree, &te[i]);
		// i[
		in_check_ply[ply + 1] = fmovecheck;
		// ̐[֐i
		int v = -quies(1 - player, -beta, -alpha, ply + 1, state);

		// ߂
		ptree = prev;
		// ԑł؂ƂȂ
		if(finterrupt)
			return -999999;

		// Jbg
		if(v >= beta)
		{
			return v;
		}
		// XV
		if(v > alpha)
		{
			alpha = v;
		}

	};//i

	return alpha;
}

// qXg[̏
void init_histry()
{
	int i, j;
	for(i = 0;i < 100;i++)
	{
		for(j = 0;j < 81;j++)
		{
			hist_good[i][j]  = 0;
			hist_tried[i][j] = 0;
		}
	}
}

//
//  ʏT
//
int alpha_beta(
	int player,
	int alpha, int beta, 
	int rdepth,				// c[
	int ply,
	int state				//
	)
{
	// ͂낢ς̂ŁAlۑB
	// nbV̓o^ŎgB
	int alpha_old = alpha;


	// ԂɒB
	if((::GetTickCount() - T0) > TIMEOUT)
	{
		DWORD tt = (::GetTickCount() - T0);
		finterrupt = 1;
		return -999999;
	}

	// Î~TsBc[PȉƂȂAȂł͂Ȃꍇ̂݁B
	if(in_check_ply[ply] == 0 && rdepth < INC_PLY)
	{
		// Î~T
		return quies(player, alpha, beta, ply + 1, state);
	};

	search_node++;

	//************************
	//    nbV
	//************************
	uint64 hash_key = ptree.hash_key;
	te_t    hash_te;
	te_t    hash_te2;
	hash_t *phash = NULL;

	// ݂̋ǖʂ̃nbVlL[ɁAnbVe[u
	if(hash_probe(player, hash_key, alpha, beta, rdepth, &phash) == 1)
	{
		// p\ȃnbVB
		pv_node[ply][ply] = phash->best;
		hash_hit++;
		return phash->value;
	}
	// p\ȃnbVȂĂA
	// nbVǖʂ̍őṔAȂɗǂ肩ȂB
	// nbVƂāAD悵ĒTB
	hash_te.from  = -10;
	hash_te2.from = -10;
	if(phash)
	{
		hash_te  = phash->best;
		hash_te2 = phash->second;
	}

	// unmake_movepɌ݂̋ǖʂۑ
	kyokumen_t prev = ptree;


	// 肩ۂ̏
	int f_in_check;
	if(ply == 0)
	{
		in_check_ply[0]   = (is_in_check(player, ptree) == -1 ? 0 : 1);
	}
	f_in_check = in_check_ply[ply];

	//
	// NULL MOVE PRUNING
	//  ȂwĂ݂āAJbgN邩ǂ`FbN
	//  ʂ́AȂƁAȂsɂȂ͂A
	//  łJbgNƂƂ́A̎_ŒTł؂Ă
	//  vł낤
	//
	int stand_pat0 = evaluate(player, ptree);
	int stand_pat  = stand_pat0 / 32;

	if( 
		f_in_check == 0        && 
		rdepth >= 2 * INC_PLY  &&
		!(state & NULL_MOVE_PRUNING_DONE)
		&&  stand_pat   >= beta 
		&&	(alpha + 1) == beta
		)
	{
		int null_depth;

		if(rdepth >= INC_PLY * 7)
		{
			null_depth = rdepth - 4 * INC_PLY;
		} else {
			null_depth = rdepth - 3 * INC_PLY;
		}
		int v = -alpha_beta(
			1 - player, 
			 -beta,
			1-beta, 
			null_depth,
			ply + 1,
			NULL_MOVE_PRUNING_DONE
			); 

		if(finterrupt)
			return -999999;
		// Jbg
		if(v >= beta)
		{
			return v;
		};// fi
	};


	int i, max_i, num;

	te_t *te = TE[ply];

	// @̐
	// 肪Ă΁A𐶐B
	if(f_in_check == 1){
		num = gen_evasion(player, &ptree, te);		// 
	} else {
		num = gen_all_moves(player, &ptree, te);	// S
	}
	// 肪ȂΏI
	if(num == 0)
	{
		return -888887;
	}

	// w̃I[_O
	for(i = 0;i < num;i++)
	{
		// ꂽ珟B
		if(abs(ptree.kifu[te[i].to]) == KOMA_OU)
			return 88888;

		// nbV
		if(hash_te == te[i])
			te[i].v = 100000;
		else if(hash_te2 == te[i])
			te[i].v = 90000;
		// L[
		else if(killer1[ply] == te[i])
			te[i].v = 15000;
		else if(killer2[ply] == te[i])
			te[i].v = 14850;
		// OC^[V̍őP
		else if(pv_node[ply][ply] == te[i])
			te[i].v = 150000;
		else
		// ȊO͓Kɕׂ
			te[i].v = rand()%5;
		// 
		if(ptree.kifu[te[i].to])
		{
			int see_v = see(player, ptree, te[i]);
			te[i].cap = 1;
			te[i].v += 10000 + see_v;
			// see̎͌
			if(see_v < 0)
				te[i].v -= 3000;
		} else {
			// uAړ
			int hv = 3000 * hist_good[10 + te[i].from][te[i].to] / (1 + hist_tried[10 + te[i].from][te[i].to]);
			te[i].v += hv;
			te[i].cap = 0;
			if(te[i].from < 0)
			{
				int see_v = see(player, ptree, te[i]);
				// see̎͌
				te[i].v += see_v;
				if(see_v < 0)
					te[i].v -= 3000;
			}
		};
	}
	// \[gs
	std::sort(&te[0], &te[num]);


	int max_v = alpha - 1, v;
	int first_move = 1;

	max_i = 0;

	// SĂ̎Ń[vs
	for(i = 0;i < num; i++)
	{

		// te[i]w̕]l̕ως
		int estimate_v0 = estimate_value(stand_pat0, player, ptree, te[i]);
		int estimate_v  = estimate_v0 / 32;
		// te[i]肩ۂ
		int fmovecheck = is_check_move(player, ptree, te[i]);
		// T[̒Zk
		int reduce = 0;
		// AT̐[Bʏ́Aݐ[P炵́B
		// ꂩAAZk肷B
		int newdepth = rdepth - INC_PLY;

		// e[uɉۑB
		in_check_ply[ply + 1] = fmovecheck;

		//
		//  T[̒ZkFReduction
		//@history reductionƂ@BłȂT[邪Aǂ݂ʂ
		//  댯邽߁AӂKvB
		//  JbgŃAZkĂȂ낤Ƃl炵B
		//  A]l̕ϓ̌AAȀꍇ
		//  sȂB
		if(   
			INC_PLY <= newdepth && 
			first_move == 0 && 
			f_in_check == 0 &&
			fmovecheck == 0 &&
			te[i].cap  == 0 &&
			te[i].nari == 0 &&
			te[i].v <= 1000
			)
		{
			
			int good  =  1 + hist_good[ te[i].from + 10][te[i].to];
			int tried = (2 + hist_tried[te[i].from + 10][te[i].to]) * 8;
			// histry pruning
			reduce = 0;
			if ( good * 160 < tried ){
				reduce = (int)(INC_PLY * 2.0);
			}
			else if ( good * 60 < tried ){
				reduce = (int)(INC_PLY * 1.5);
			}
			else if ( good * 20 < tried ){
				reduce = (int)(INC_PLY * 1.0);
			}
			newdepth -= reduce;
		}

		// futility cut
		if( 0&&
			f_in_check == 0 && fmovecheck == 0 && i > 0 && newdepth < 3 * INC_PLY)
		{
			int bound = alpha;

			// pre-frontia
			if(newdepth >= 2 * INC_PLY)
				bound -= 400;
			// frontia
			else if(newdepth >= 1 * INC_PLY)
				bound -= 400;

			if(abs(ptree.kifu[te[i].from]) == KOMA_OU)
			{
				bound = alpha - 1600;
			}

			if(estimate_v <= bound) 
			{
				// ߂
				continue;
			};
		}

		// i߂
		make_move(player, &ptree, &te[i]);

		// sĂړȂ̂Ń`FbN
		if(te[i].from >= 0 && 
			(rel_2koma[player][te[i].to][ptree.king_pos[player]]   ||
			 rel_2koma[player][te[i].from][ptree.king_pos[player]])
			 && is_in_check(player, ptree) != -1)
		{
			// ߂
			ptree = prev;
			continue;
		}

		// OwĎ̕ۑ
		last_move[ply] = te[i];
		// ̉
		if(fmovecheck && te[i].v > 0)
		{
			newdepth += INC_PLY;
		}
		//
		//  PVT[`B
		// Pڂ͂܂ƂɒTBQڂ́A܂null windowŒTāAlz΁ASwindowŒTȂB
		//
		if(first_move == 1)
		{
			v = -alpha_beta(1 - player, -beta, -alpha, newdepth, ply + 1, state);
			first_move = 0;
		} else {
			// Null window
			v = -alpha_beta(1 - player, -alpha-1, -alpha, newdepth, ply + 1, state);

			// Zkꍇ́AZkȂčĒT
			if(v > alpha && reduce)
			{
				newdepth = rdepth - INC_PLY;
				v = -alpha_beta(1 - player, -alpha-1, -alpha, newdepth, ply + 1, NULL_MOVE_PRUNING_DONE);
			}
			// łl𒴂΁AēxASwindowŒTȂ
			if(v > alpha)
			{
				v = -alpha_beta(1 - player, -beta, -alpha, newdepth, ply + 1, NULL_MOVE_PRUNING_DONE);
			}
		}

		// ߂
		ptree = prev;

		// Ԃ𒴂
		if(finterrupt)
			return -999999;

		// qXg[XV
		if(te[i].cap == 0)
		{
			hist_tried[10 + te[i].from][te[i].to] += rdepth;
			// l̃I[ot[h߁Al𒴂ƂQŊ悤ɂB
			if(hist_tried[10 + te[i].from][te[i].to] > 10000)
			{
				hist_tried[10 + te[i].from][te[i].to] /= 2;
				hist_good[10 + te[i].from][te[i].to]  /= 2;
			}
		}

		// x[^Jbg
		if(v >= beta)
		{
			// ̎͗ǂƂāAqXg[ɉZ
			if(te[i].cap == 0)
				hist_good[10 + te[i].from][te[i].to] += rdepth;

			// L[ɓo^
			killer2[ply] = killer1[ply];
			killer1[ply] = te[i];

			max_v = v;
			max_i = i;
			goto ADD_HASH;
		}
		// XV(=͂Ȃ)
		if(v > alpha)
		{
			max_i = i;
			max_v = alpha = v;
			// őP̕ۑ
			pv_node[ply][ply] = te[i];
			int n;
			for(n = ply + 1;n < 10;n++)
			{
				pv_node[ply][n] = pv_node[ply + 1][n];
			};
			pv_node[ply+1][ply+1].from = -10;
			// őP̕\
			if(ply == 0)
			{	
				int n;
				char yomisuzi[256] = {0};
				for(n = 0;n < 10;n++)
				{
					if(pv_node[0][n].from <= -10)
						break;
					strcat(yomisuzi, te_name(pv_node[0][n]));
					strcat(yomisuzi, "-");
				}

				printf("info depth %d score cp %d nodes %d ", iteration, max_v, search_node, hash_hit);
				printf("info string %s\n", yomisuzi);

			}
		}
	};//i

	// 肪Ȃ
	if(first_move == 1)
	{
		return -888887;
	}
	// nbV̒lɏ]ēo^B
	// Aalpha͐FXXVĕςĂ̂
	// ŏ̃l(alpha_old)pB
ADD_HASH:
	hash_entry(hash_key, player, max_v, alpha_old, beta, rdepth, te[max_i]);

	return max_v;
};

// C^[V
int iterate(
	int player,
	int alpha, int beta, 
	int rdepth,				// c[
	int ply,
	int state,
	int stand_pat
	)
{
	int idepth;
	int v;

	pv_node[ply][ply].from = -10;
	te_t best;
	best.from = -10;

	pv_node[ply][ply] = best;

	int max_v, last_v = 0;

	max_v  = VMIN;
	for(idepth = 3 * INC_PLY; idepth <= rdepth; idepth+= INC_PLY)
	{
		iteration = idepth / INC_PLY;
		v = alpha_beta(player, alpha, beta, idepth, ply, state);
		if(finterrupt == 0)
		{
			max_v = v;
			best = pv_node[ply][ply];
		} else break;
	}

	// őP̕\
	if(ply == 0)
	{	
		int n;
		char yomisuzi[256] = {0};
		for(n = 0;n < 10;n++)
		{
			if(pv_node[0][n].from <= -10)
				break;
			strcat(yomisuzi, te_name(pv_node[0][n]));
			strcat(yomisuzi, "-");
		}

		printf("info depth %d score cp %d nodes %d ", iteration, max_v, search_node, hash_hit);
		printf("info string %s\n", yomisuzi);
	}

	pv_node[ply][ply] = best;

	return max_v;
}

